
_MP3_Init:

;Mp3.c,35 :: 		void MP3_Init()
;Mp3.c,38 :: 		DCLK_Direction  = 0;
	BCF         TRISH3_bit+0, 3 
;Mp3.c,39 :: 		SDATA_Direction = 0;
	BCF         TRISD2_bit+0, 2 
;Mp3.c,40 :: 		DCLK  = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,41 :: 		SDATA = 0;
	BCF         LATD2_bit+0, 2 
;Mp3.c,43 :: 		MP3_CS_Direction  = 0;
	BCF         TRISB4_bit+0, 4 
;Mp3.c,44 :: 		MP3_CS            = 1;
	BSF         LATB4_bit+0, 4 
;Mp3.c,45 :: 		MP3_RST_Direction = 0;
	BCF         TRISH0_bit+0, 0 
;Mp3.c,46 :: 		MP3_RST           = 1;
	BSF         LATH0_bit+0, 0 
;Mp3.c,48 :: 		DREQ_Direction  = 1;
	BSF         TRISH7_bit+0, 7 
;Mp3.c,49 :: 		BSYNC_Direction = 0;
	BCF         TRISB5_bit+0, 5 
;Mp3.c,50 :: 		BSYNC           = 0;
	BCF         LATB5_bit+0, 5 
;Mp3.c,52 :: 		}
L_end_MP3_Init:
	RETURN      0
; end of _MP3_Init

_MP3_Soft_Reset:

;Mp3.c,56 :: 		void MP3_Soft_Reset(char fill_zeros)
;Mp3.c,61 :: 		MP3_SCI_Write(MODE_ADDR,0x0204);
	CLRF        FARG_MP3_SCI_Write_address+0 
	MOVLW       4
	MOVWF       FARG_MP3_SCI_Write_data_in+0 
	MOVLW       2
	MOVWF       FARG_MP3_SCI_Write_data_in+1 
	CALL        _MP3_SCI_Write+0, 0
;Mp3.c,63 :: 		Delay_us(2);
	MOVLW       7
	MOVWF       R13, 0
L_MP3_Soft_Reset0:
	DECFSZ      R13, 1, 1
	BRA         L_MP3_Soft_Reset0
	NOP
	NOP
;Mp3.c,64 :: 		while (DREQ == 0);
L_MP3_Soft_Reset1:
	BTFSC       RH7_bit+0, 7 
	GOTO        L_MP3_Soft_Reset2
	GOTO        L_MP3_Soft_Reset1
L_MP3_Soft_Reset2:
;Mp3.c,65 :: 		if (fill_zeros)
	MOVF        FARG_MP3_Soft_Reset_fill_zeros+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_MP3_Soft_Reset3
;Mp3.c,67 :: 		for (i=0; i<32; i++)
	CLRF        MP3_Soft_Reset_i_L0+0 
L_MP3_Soft_Reset4:
	MOVLW       32
	SUBWF       MP3_Soft_Reset_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MP3_Soft_Reset5
;Mp3.c,69 :: 		data_buffer_32[i] = 0;
	MOVLW       _data_buffer_32+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(_data_buffer_32+0)
	MOVWF       FSR1H 
	MOVF        MP3_Soft_Reset_i_L0+0, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	CLRF        POSTINC1+0 
;Mp3.c,67 :: 		for (i=0; i<32; i++)
	INCF        MP3_Soft_Reset_i_L0+0, 1 
;Mp3.c,70 :: 		}
	GOTO        L_MP3_Soft_Reset4
L_MP3_Soft_Reset5:
;Mp3.c,71 :: 		for (i=0; i < 2048/32; i++)
	CLRF        MP3_Soft_Reset_i_L0+0 
L_MP3_Soft_Reset7:
	MOVLW       64
	SUBWF       MP3_Soft_Reset_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MP3_Soft_Reset8
;Mp3.c,73 :: 		MP3_SDI_Write_32(data_buffer_32);
	MOVLW       _data_buffer_32+0
	MOVWF       FARG_MP3_SDI_Write_32_data_+0 
	MOVLW       hi_addr(_data_buffer_32+0)
	MOVWF       FARG_MP3_SDI_Write_32_data_+1 
	CALL        _MP3_SDI_Write_32+0, 0
;Mp3.c,71 :: 		for (i=0; i < 2048/32; i++)
	INCF        MP3_Soft_Reset_i_L0+0, 1 
;Mp3.c,74 :: 		}
	GOTO        L_MP3_Soft_Reset7
L_MP3_Soft_Reset8:
;Mp3.c,75 :: 		}
	GOTO        L_MP3_Soft_Reset10
L_MP3_Soft_Reset3:
;Mp3.c,77 :: 		MP3_SDI_Write(0);
	CLRF        FARG_MP3_SDI_Write_data_+0 
	CALL        _MP3_SDI_Write+0, 0
L_MP3_Soft_Reset10:
;Mp3.c,79 :: 		}
L_end_MP3_Soft_Reset:
	RETURN      0
; end of _MP3_Soft_Reset

_MP3_Set_Clock:

;Mp3.c,83 :: 		void MP3_Set_Clock(unsigned int clock_khz, char doubler)
;Mp3.c,86 :: 		clock_khz /= 2;
	RRCF        FARG_MP3_Set_Clock_clock_khz+1, 1 
	RRCF        FARG_MP3_Set_Clock_clock_khz+0, 1 
	BCF         FARG_MP3_Set_Clock_clock_khz+1, 7 
;Mp3.c,87 :: 		if (doubler)
	MOVF        FARG_MP3_Set_Clock_doubler+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_MP3_Set_Clock11
;Mp3.c,89 :: 		clock_khz |= 0x8000;
	BSF         FARG_MP3_Set_Clock_clock_khz+1, 7 
;Mp3.c,90 :: 		}
L_MP3_Set_Clock11:
;Mp3.c,91 :: 		MP3_SCI_Write(CLOCKF_ADDR, clock_khz);
	MOVLW       3
	MOVWF       FARG_MP3_SCI_Write_address+0 
	MOVF        FARG_MP3_Set_Clock_clock_khz+0, 0 
	MOVWF       FARG_MP3_SCI_Write_data_in+0 
	MOVF        FARG_MP3_Set_Clock_clock_khz+1, 0 
	MOVWF       FARG_MP3_SCI_Write_data_in+1 
	CALL        _MP3_SCI_Write+0, 0
;Mp3.c,93 :: 		}
L_end_MP3_Set_Clock:
	RETURN      0
; end of _MP3_Set_Clock

_MP3_Set_Volume:

;Mp3.c,97 :: 		void MP3_Set_Volume(char left,char right)
;Mp3.c,102 :: 		volume = (left<<8) + right;
	MOVF        FARG_MP3_Set_Volume_left+0, 0 
	MOVWF       FARG_MP3_SCI_Write_data_in+1 
	CLRF        FARG_MP3_SCI_Write_data_in+0 
	MOVF        FARG_MP3_Set_Volume_right+0, 0 
	ADDWF       FARG_MP3_SCI_Write_data_in+0, 1 
	MOVLW       0
	ADDWFC      FARG_MP3_SCI_Write_data_in+1, 1 
;Mp3.c,103 :: 		MP3_SCI_Write(VOL_ADDR, volume);
	MOVLW       11
	MOVWF       FARG_MP3_SCI_Write_address+0 
	CALL        _MP3_SCI_Write+0, 0
;Mp3.c,105 :: 		}
L_end_MP3_Set_Volume:
	RETURN      0
; end of _MP3_Set_Volume

_MP3_Reset:

;Mp3.c,109 :: 		void MP3_Reset(char volume)
;Mp3.c,111 :: 		MP3_Soft_Reset(0);
	CLRF        FARG_MP3_Soft_Reset_fill_zeros+0 
	CALL        _MP3_Soft_Reset+0, 0
;Mp3.c,112 :: 		MP3_Set_Clock(25000,0);
	MOVLW       168
	MOVWF       FARG_MP3_Set_Clock_clock_khz+0 
	MOVLW       97
	MOVWF       FARG_MP3_Set_Clock_clock_khz+1 
	CLRF        FARG_MP3_Set_Clock_doubler+0 
	CALL        _MP3_Set_Clock+0, 0
;Mp3.c,113 :: 		MP3_Set_Volume(volume,volume);
	MOVF        FARG_MP3_Reset_volume+0, 0 
	MOVWF       FARG_MP3_Set_Volume_left+0 
	MOVF        FARG_MP3_Reset_volume+0, 0 
	MOVWF       FARG_MP3_Set_Volume_right+0 
	CALL        _MP3_Set_Volume+0, 0
;Mp3.c,114 :: 		}
L_end_MP3_Reset:
	RETURN      0
; end of _MP3_Reset

_SW_SPI_Write:

;Mp3.c,118 :: 		void SW_SPI_Write(char data_)
;Mp3.c,120 :: 		BSYNC = 1;
	BSF         LATB5_bit+0, 5 
;Mp3.c,122 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,123 :: 		SDATA = data_;
	BTFSC       FARG_SW_SPI_Write_data_+0, 0 
	GOTO        L__SW_SPI_Write31
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write32
L__SW_SPI_Write31:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write32:
;Mp3.c,124 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,125 :: 		data_ >>= 1;
	MOVF        FARG_SW_SPI_Write_data_+0, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	BCF         R1, 7 
	MOVF        R1, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,127 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,128 :: 		SDATA = data_;
	BTFSC       R1, 0 
	GOTO        L__SW_SPI_Write33
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write34
L__SW_SPI_Write33:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write34:
;Mp3.c,129 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,130 :: 		data_ >>= 1;
	MOVF        R1, 0 
	MOVWF       R2 
	RRCF        R2, 1 
	BCF         R2, 7 
	MOVF        R2, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,132 :: 		BSYNC = 0;
	BCF         LATB5_bit+0, 5 
;Mp3.c,134 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,135 :: 		SDATA = data_;
	BTFSC       R2, 0 
	GOTO        L__SW_SPI_Write35
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write36
L__SW_SPI_Write35:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write36:
;Mp3.c,136 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,137 :: 		data_ >>= 1;
	MOVF        R2, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	BCF         R1, 7 
	MOVF        R1, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,139 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,140 :: 		SDATA = data_;
	BTFSC       R1, 0 
	GOTO        L__SW_SPI_Write37
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write38
L__SW_SPI_Write37:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write38:
;Mp3.c,141 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,142 :: 		data_ >>= 1;
	MOVF        R1, 0 
	MOVWF       R2 
	RRCF        R2, 1 
	BCF         R2, 7 
	MOVF        R2, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,144 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,145 :: 		SDATA = data_;
	BTFSC       R2, 0 
	GOTO        L__SW_SPI_Write39
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write40
L__SW_SPI_Write39:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write40:
;Mp3.c,146 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,147 :: 		data_ >>= 1;
	MOVF        R2, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	BCF         R1, 7 
	MOVF        R1, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,149 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,150 :: 		SDATA = data_;
	BTFSC       R1, 0 
	GOTO        L__SW_SPI_Write41
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write42
L__SW_SPI_Write41:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write42:
;Mp3.c,151 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,152 :: 		data_ >>= 1;
	MOVF        R1, 0 
	MOVWF       R2 
	RRCF        R2, 1 
	BCF         R2, 7 
	MOVF        R2, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,154 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,155 :: 		SDATA = data_;
	BTFSC       R2, 0 
	GOTO        L__SW_SPI_Write43
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write44
L__SW_SPI_Write43:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write44:
;Mp3.c,156 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,157 :: 		data_ >>= 1;
	MOVF        R2, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	BCF         R1, 7 
	MOVF        R1, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
;Mp3.c,159 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,160 :: 		SDATA = data_;
	BTFSC       R1, 0 
	GOTO        L__SW_SPI_Write45
	BCF         LATD2_bit+0, 2 
	GOTO        L__SW_SPI_Write46
L__SW_SPI_Write45:
	BSF         LATD2_bit+0, 2 
L__SW_SPI_Write46:
;Mp3.c,161 :: 		DCLK = 1;
	BSF         LATH3_bit+0, 3 
;Mp3.c,162 :: 		data_ >>= 1;
	MOVF        R1, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
	RRCF        FARG_SW_SPI_Write_data_+0, 1 
	BCF         FARG_SW_SPI_Write_data_+0, 7 
;Mp3.c,164 :: 		DCLK = 0;
	BCF         LATH3_bit+0, 3 
;Mp3.c,165 :: 		}
L_end_SW_SPI_Write:
	RETURN      0
; end of _SW_SPI_Write

_MP3_SCI_Write:

;Mp3.c,169 :: 		void MP3_SCI_Write(char address, unsigned int data_in)
;Mp3.c,172 :: 		MP3_CS = 0;
	BCF         LATB4_bit+0, 4 
;Mp3.c,173 :: 		SPI1_Write(WRITE_CODE);
	MOVLW       2
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;Mp3.c,174 :: 		SPI1_Write(address);
	MOVF        FARG_MP3_SCI_Write_address+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;Mp3.c,175 :: 		SPI1_Write(Hi(data_in));
	MOVF        FARG_MP3_SCI_Write_data_in+1, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;Mp3.c,176 :: 		SPI1_Write(Lo(data_in));
	MOVF        FARG_MP3_SCI_Write_data_in+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;Mp3.c,177 :: 		MP3_CS = 1;
	BSF         LATB4_bit+0, 4 
;Mp3.c,179 :: 		while (DREQ == 0);
L_MP3_SCI_Write12:
	BTFSC       RH7_bit+0, 7 
	GOTO        L_MP3_SCI_Write13
	GOTO        L_MP3_SCI_Write12
L_MP3_SCI_Write13:
;Mp3.c,181 :: 		}
L_end_MP3_SCI_Write:
	RETURN      0
; end of _MP3_SCI_Write

_MP3_SCI_Read:

;Mp3.c,185 :: 		void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer)
;Mp3.c,190 :: 		MP3_CS = 0;
	BCF         LATB4_bit+0, 4 
;Mp3.c,192 :: 		SPI1_Write(READ_CODE);
	MOVLW       3
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;Mp3.c,193 :: 		SPI1_Write(start_address);
	MOVF        FARG_MP3_SCI_Read_start_address+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;Mp3.c,195 :: 		while (words_count--)
L_MP3_SCI_Read14:
	MOVF        FARG_MP3_SCI_Read_words_count+0, 0 
	MOVWF       R0 
	DECF        FARG_MP3_SCI_Read_words_count+0, 1 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_MP3_SCI_Read15
;Mp3.c,197 :: 		temp = SPI1_Read(0);
	CLRF        FARG_SPI1_Read_buffer+0 
	CALL        _SPI1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       MP3_SCI_Read_temp_L0+0 
	MOVLW       0
	MOVWF       MP3_SCI_Read_temp_L0+1 
;Mp3.c,198 :: 		temp <<= 8;
	MOVF        MP3_SCI_Read_temp_L0+0, 0 
	MOVWF       MP3_SCI_Read_temp_L0+1 
	CLRF        MP3_SCI_Read_temp_L0+0 
;Mp3.c,199 :: 		temp += SPI1_Read(0);
	CLRF        FARG_SPI1_Read_buffer+0 
	CALL        _SPI1_Read+0, 0
	MOVLW       0
	MOVWF       R1 
	MOVF        MP3_SCI_Read_temp_L0+0, 0 
	ADDWF       R0, 1 
	MOVF        MP3_SCI_Read_temp_L0+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       MP3_SCI_Read_temp_L0+0 
	MOVF        R1, 0 
	MOVWF       MP3_SCI_Read_temp_L0+1 
;Mp3.c,200 :: 		*(data_buffer++) = temp;
	MOVFF       FARG_MP3_SCI_Read_data_buffer+0, FSR1L
	MOVFF       FARG_MP3_SCI_Read_data_buffer+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
	MOVLW       2
	ADDWF       FARG_MP3_SCI_Read_data_buffer+0, 1 
	MOVLW       0
	ADDWFC      FARG_MP3_SCI_Read_data_buffer+1, 1 
;Mp3.c,201 :: 		}
	GOTO        L_MP3_SCI_Read14
L_MP3_SCI_Read15:
;Mp3.c,202 :: 		MP3_CS = 1;
	BSF         LATB4_bit+0, 4 
;Mp3.c,204 :: 		while (DREQ == 0);
L_MP3_SCI_Read16:
	BTFSC       RH7_bit+0, 7 
	GOTO        L_MP3_SCI_Read17
	GOTO        L_MP3_SCI_Read16
L_MP3_SCI_Read17:
;Mp3.c,206 :: 		}
L_end_MP3_SCI_Read:
	RETURN      0
; end of _MP3_SCI_Read

_MP3_SDI_Write:

;Mp3.c,210 :: 		void MP3_SDI_Write(char data_)
;Mp3.c,213 :: 		while (DREQ == 0);
L_MP3_SDI_Write18:
	BTFSC       RH7_bit+0, 7 
	GOTO        L_MP3_SDI_Write19
	GOTO        L_MP3_SDI_Write18
L_MP3_SDI_Write19:
;Mp3.c,214 :: 		SW_SPI_Write(data_);
	MOVF        FARG_MP3_SDI_Write_data_+0, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
	CALL        _SW_SPI_Write+0, 0
;Mp3.c,216 :: 		}
L_end_MP3_SDI_Write:
	RETURN      0
; end of _MP3_SDI_Write

_MP3_SDI_Write_32:

;Mp3.c,220 :: 		void MP3_SDI_Write_32(char *data_)
;Mp3.c,224 :: 		while (DREQ == 0);
L_MP3_SDI_Write_3220:
	BTFSC       RH7_bit+0, 7 
	GOTO        L_MP3_SDI_Write_3221
	GOTO        L_MP3_SDI_Write_3220
L_MP3_SDI_Write_3221:
;Mp3.c,226 :: 		for (i=0; i<32; i++)
	CLRF        MP3_SDI_Write_32_i_L0+0 
L_MP3_SDI_Write_3222:
	MOVLW       32
	SUBWF       MP3_SDI_Write_32_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_MP3_SDI_Write_3223
;Mp3.c,227 :: 		SW_SPI_Write(data_[i]);
	MOVF        MP3_SDI_Write_32_i_L0+0, 0 
	ADDWF       FARG_MP3_SDI_Write_32_data_+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_MP3_SDI_Write_32_data_+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_SW_SPI_Write_data_+0 
	CALL        _SW_SPI_Write+0, 0
;Mp3.c,226 :: 		for (i=0; i<32; i++)
	INCF        MP3_SDI_Write_32_i_L0+0, 1 
;Mp3.c,227 :: 		SW_SPI_Write(data_[i]);
	GOTO        L_MP3_SDI_Write_3222
L_MP3_SDI_Write_3223:
;Mp3.c,229 :: 		}
L_end_MP3_SDI_Write_32:
	RETURN      0
; end of _MP3_SDI_Write_32

_MP3_Read_Time:

;Mp3.c,233 :: 		void MP3_Read_Time(unsigned int* seconds)
;Mp3.c,235 :: 		MP3_SCI_Read(DECODE_TIME, 1, seconds);
	MOVLW       4
	MOVWF       FARG_MP3_SCI_Read_start_address+0 
	MOVLW       1
	MOVWF       FARG_MP3_SCI_Read_words_count+0 
	MOVF        FARG_MP3_Read_Time_seconds+0, 0 
	MOVWF       FARG_MP3_SCI_Read_data_buffer+0 
	MOVF        FARG_MP3_Read_Time_seconds+1, 0 
	MOVWF       FARG_MP3_SCI_Read_data_buffer+1 
	CALL        _MP3_SCI_Read+0, 0
;Mp3.c,236 :: 		}
L_end_MP3_Read_Time:
	RETURN      0
; end of _MP3_Read_Time

Mp3____?ag:

L_end_Mp3___?ag:
	RETURN      0
; end of Mp3____?ag
