#line 1 "D:/Projets Mikroe/PlayerMp3/Mp3.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "d:/projets mikroe/playermp3/mp3.h"



void MP3_Init();
void MP3_Set_Volume(char left,char right);
void MP3_Reset(char volume);
void MP3_SCI_Write(char address, unsigned int data_in);
void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer);
void MP3_SDI_Write_32(char *data_);
void MP3_SDI_Write(char data_);
void MP3_Read_Time(unsigned int *seconds);
#line 8 "D:/Projets Mikroe/PlayerMp3/Mp3.c"
sbit MP3_CS at LATB4_bit;
sbit MP3_RST at LATH0_bit;
sbit DREQ at RH7_bit;
sbit BSYNC at LATB5_bit;
sbit DCLK at LATH3_bit;
sbit SDATA at LATD2_bit;

sbit MP3_CS_Direction at TRISB4_bit;
sbit MP3_RST_Direction at TRISH0_bit;
sbit DREQ_Direction at TRISH7_bit;
sbit BSYNC_Direction at TRISB5_bit;
sbit DCLK_Direction at TRISH3_bit;
sbit SDATA_Direction at TRISD2_bit;



const char WRITE_CODE = 0x02;
const char READ_CODE = 0x03;
const char MODE_ADDR = 0x00;
const char CLOCKF_ADDR = 0x03;
const char VOL_ADDR = 0x0B;
const char DECODE_TIME = 0x04;

char data_buffer_32[32];



void MP3_Init()
{

 DCLK_Direction = 0;
 SDATA_Direction = 0;
 DCLK = 0;
 SDATA = 0;

 MP3_CS_Direction = 0;
 MP3_CS = 1;
 MP3_RST_Direction = 0;
 MP3_RST = 1;

 DREQ_Direction = 1;
 BSYNC_Direction = 0;
 BSYNC = 0;

}



void MP3_Soft_Reset(char fill_zeros)
{

 char i;

 MP3_SCI_Write(MODE_ADDR,0x0204);

 Delay_us(2);
 while (DREQ == 0);
 if (fill_zeros)
 {
 for (i=0; i<32; i++)
 {
 data_buffer_32[i] = 0;
 }
 for (i=0; i < 2048/32; i++)
 {
 MP3_SDI_Write_32(data_buffer_32);
 }
 }
 else
 MP3_SDI_Write(0);

}



void MP3_Set_Clock(unsigned int clock_khz, char doubler)
{

 clock_khz /= 2;
 if (doubler)
 {
 clock_khz |= 0x8000;
 }
 MP3_SCI_Write(CLOCKF_ADDR, clock_khz);

}



void MP3_Set_Volume(char left,char right)
{

 unsigned int volume;

 volume = (left<<8) + right;
 MP3_SCI_Write(VOL_ADDR, volume);

}



void MP3_Reset(char volume)
{
 MP3_Soft_Reset(0);
 MP3_Set_Clock(25000,0);
 MP3_Set_Volume(volume,volume);
}



void SW_SPI_Write(char data_)
{
 BSYNC = 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 BSYNC = 0;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
 SDATA = data_;
 DCLK = 1;
 data_ >>= 1;

 DCLK = 0;
}



void MP3_SCI_Write(char address, unsigned int data_in)
{

 MP3_CS = 0;
 SPI1_Write(WRITE_CODE);
 SPI1_Write(address);
 SPI1_Write( ((char *)&data_in)[1] );
 SPI1_Write( ((char *)&data_in)[0] );
 MP3_CS = 1;

 while (DREQ == 0);

}



void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer)
{

 unsigned int temp;

 MP3_CS = 0;

 SPI1_Write(READ_CODE);
 SPI1_Write(start_address);

 while (words_count--)
 {
 temp = SPI1_Read(0);
 temp <<= 8;
 temp += SPI1_Read(0);
 *(data_buffer++) = temp;
 }
 MP3_CS = 1;

 while (DREQ == 0);

}



void MP3_SDI_Write(char data_)
{

 while (DREQ == 0);
 SW_SPI_Write(data_);

}



void MP3_SDI_Write_32(char *data_)
{
 char i;

 while (DREQ == 0);

 for (i=0; i<32; i++)
 SW_SPI_Write(data_[i]);

}



void MP3_Read_Time(unsigned int* seconds)
{
 MP3_SCI_Read(DECODE_TIME, 1, seconds);
}
